<?php 
/**
 * Nexter Settings Panel
 *
 * @package	Nexter
 * @since	1.0.0
 */
if (!defined('ABSPATH')) {
    exit;
}
/**
 * White Label Content
 */
function nexter_white_label_content(){
	echo '<div class="nxt-pro-note-title"><p style="margin-bottom:50px;">'.esc_html__('White Label our plugin and setup client\'s branding all around. You can update name, description, Icon and even hide the menu from dashboard. Get our pro version to have access of this feature.','nexter').'</p></div>
		<div style="text-align:center;">
			<img style="width:55%;" src="'.esc_url(NXT_THEME_URI .'assets/images/white-lable.png').'" alt="'.esc_attr__('White Label','nexter').'" class="panel-plus-white-lable" />
		</div>';
}
add_action('nexter_white_label_notice', 'nexter_white_label_content' );

/**
 * Activate Content
 */
function nexter_activate_content(){
	echo '<div class="nxt-pro-note-title"><p style="margin-bottom:40px;">'.esc_html__('Upgrade to Pro version to get lots more Features and Lot more.','nexter').'</p></div>
		<div style="text-align:center;">
			<img style="width:55%;" src="'.esc_url(NXT_THEME_URI .'assets/images/activate.png').'" alt="'.esc_attr__('Activate','nexter').'" class="panel-plus-activate" />
		</div>
		<div class="nxt-pro-note-link"><a href="'.esc_url('https://theplusaddons.com/free-vs-pro-compare/').'" target="_blank">'.esc_html__('Compare Free vs Pro','nexter').'</a></div>';
}
add_action('nexter_activate_notice', 'nexter_activate_content' );

class Nexter_Settings_Panel {
	
	/**
     * Option key, and option page slug
     */
    private $key = 'nexter_settings_opts';
	
	/**
     * Array of meta boxes/fields
     * @var array
     */
    protected $option_metabox = array();
    
	/**
     * Setting Name/Title
     * @var string
     */
    protected $setting_name = '';
	
	/**
     * Constructor
     * @since 1.0.0
     */
    public function __construct() {
		
		if(defined('NXT_PRO_EXT')){
			$options = get_option( 'nexter_white_label' );
			$this->setting_name = (!empty($options['brand_name'])) ? $options['brand_name'].esc_html__(' Settings', 'nexter') : esc_html__('Nexter Settings', 'nexter');
		}else{
			$this->setting_name = esc_html__('Nexter Settings', 'nexter');
		}
		
        $this->fields = array();
    }
	
	/**
     * Initiate hooks
     */
	public function hooks() {
        add_action('admin_init', array( $this,'init' ) );
        add_action('admin_menu', array( $this, 'nxt_add_menu_page' ));
    }
	
	/**
     * Register nexter setting to WP
     */
    public function init() {
        $option_tabs = self::option_fields();
		
        foreach ($option_tabs as $index => $option_tab) {
            register_setting($option_tab['id'], $option_tab['id']);
        }
    }
	
	/**
     * Add menu options page
     */
    public function nxt_add_menu_page() {
		$option_tabs = self::option_fields();
		global $_registered_pages, $submenu;
		
		unset($submenu['themes.php'][20]);
		unset($submenu['themes.php'][15]);
		
		foreach ($option_tabs as $index => $option_tab) {
			if($index == 0){
				add_theme_page($this->setting_name, $this->setting_name, 'manage_options', $option_tab['id'], array(
					$this,
					'admin_page_display'
				));
			}else{
				$function_name = array( $this,'admin_page_display');
				$hookname = get_plugin_page_hookname( $option_tab['id'], $option_tabs[0]['id'] );
				if ( ! empty( $function_name ) && ! empty( $hookname ) ) {
					add_action( $hookname, $function_name );
				}
				$_registered_pages[ $hookname ] = true;	// phpcs:ignore WordPress.WP.GlobalVariablesOverride.Prohibited
			}
		}
    }
	
	/**
     * Theplus Gutenberg Display Page
     * @since  1.0.0
     */
    public function admin_page_display() {
		$option_tabs = self::option_fields();
		$tab_forms   = array();
		
		$output ='';
		
		$output .='<div class="'.esc_attr($this->key).'">';
			
			$output .='<div id="nxt-setting-header-wrapper">';
				$output .='<div class="nxt-head-inner">';
				
					$options = get_option( 'nexter_white_label' );
					if(defined('NXT_PRO_EXT') && (!empty($options['theme_logo']))){
						$output .='<img src="'.esc_url($options['theme_logo']).'" style="max-width:150px;"/>';
					}else{
						$output .='<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="200" viewBox="0 0 865.58 276.42"><defs><clipPath transform="translate(-561.27 -385.08)"><rect width="1920" height="1080" style="fill:none"/></clipPath></defs><title>Nexter</title><polygon points="195.86 96.47 151.62 0.76 121.98 0.76 121.98 272.27 151.62 272.27 151.62 49.42 195.8 145.11 195.86 272.27 225.5 272.27 225.5 0.76 195.86 0.76 195.86 96.47" style="fill:#fff"/><g style="clip-path:url(#3002fa26-8adc-47a4-847a-87495272d705)"><path d="M1011.75,550.7c0,1.93-1.16,3.43-3.47,4.52l-18.76,7.26-18.78-7.15c-2.32-1.06-3.47-2.59-3.47-4.53V385.19l-29.61-.11V551.24q0,13.95,16.91,22.1l5.31,2.53-5.31,2.54q-16.91,8.15-16.91,22.06v56.11h29.69V601.21c0-2,1.16-3.63,3.47-4.72l18.7-7.23,18.68,7.23c2.31,1.09,3.47,2.68,3.47,4.72v55.37h29.75V600.47q0-13.9-16.92-22.06l-5.31-2.54,5.31-2.53q16.9-8.15,16.92-22.1V385.08h-29.67Z" transform="translate(-561.27 -385.08)" style="fill:#fff"/><polygon points="512.73 23.95 548.43 23.92 548.43 272.27 577.99 272.27 578.09 23.92 613.74 23.92 613.74 0.76 512.76 0.76 512.73 23.95" style="fill:#fff"/><path d="M1408,604.24q18.81-6.35,18.79-23.35V411.18c0-7-3.23-13-9.62-18s-11.15-7.53-19.94-7.53h-71.34V657.18h29.64v0h0V615.84h30.21c.25,0,.46.09.69.12a14.56,14.56,0,0,1,3.81.93c.4.14.76.3,1.13.47l.3.14a9.54,9.54,0,0,1,4.58,4.32l.12.22a9.17,9.17,0,0,1,.46,1.21,8.64,8.64,0,0,1,.24.83,13.57,13.57,0,0,1,.35,3l-.14,30.11h0v0h29.67v-29.4c0-11.35-6.36-19.21-18.9-23.54m-10.77-21.36a8.52,8.52,0,0,1-3.72,6.87,14.13,14.13,0,0,1-9,2.9h-29V409h34.82a7.83,7.83,0,0,1,4.85,1.55,4.61,4.61,0,0,1,2.09,3.87Z" transform="translate(-561.27 -385.08)" style="fill:#fff"/><polygon points="258.11 272.24 343.8 272.24 343.8 249.03 287.83 249.03 287.83 202.52 327.5 202.52 327.5 179.34 287.83 179.34 287.83 23.92 343.8 23.92 343.8 0.74 258.11 0.74 258.11 272.24" style="fill:#fff"/><polygon points="646.32 23.95 702.32 23.98 702.32 84.61 662.66 84.61 662.66 107.82 702.29 107.82 702.29 249.08 646.32 249.08 646.32 272.27 732.04 272.27 732.04 0.76 646.32 0.76 646.32 23.95" style="fill:#fff"/><path d="M605.76,630.6l-.14,30.9H561.27V618.58h32.08c.28,0,.49.1.73.13a15.32,15.32,0,0,1,4,1c.41.14.83.32,1.22.49.1.07.21.11.31.18a10,10,0,0,1,4.85,4.6c.07.11.1.18.14.24a8.36,8.36,0,0,1,.49,1.29,5.33,5.33,0,0,1,.24.91,13.24,13.24,0,0,1,.38,3.17" transform="translate(-561.27 -385.08)" style="fill:#fff"/><path d="M605.62,402.47v180.7c0,2.82-1.29,5.26-3.94,7.36a14.86,14.86,0,0,1-9.59,3.1H561.27v-197h37a8.31,8.31,0,0,1,5.16,1.67,5,5,0,0,1,2.19,4.15" transform="translate(-561.27 -385.08)" style="fill:#fff"/></g></svg>';
					}
					$output .='<div class="nxt-panel-head-inner">';
						$output .='<h2 class="nxt-head-setting-panel">'.esc_html__('Setting Panel','nexter').'</h2>';
						$output .='<div class="nxt-current-version"> '.esc_html__('Version','nexter').' '.NXT_VERSION.'</div>';
					$output .='</div>';
				$output .='</div>';
				
				$output .='<div class="nxt-nav-tab-wrapper">';
					$output .='<div class="nav-tab-wrapper">';
						ob_start();
						foreach ($option_tabs as $option_tab):
							$tab_slug  = $option_tab['id'];
							$nav_class = 'nav-tab';
							if (isset($_GET['page']) && $tab_slug == $_GET['page']) {
								$nav_class .= ' nav-tab-active'; //add active class to current tab
								$tab_forms[] = $option_tab; //add current tab to forms to be rendered
							}
							$navicon = $nav_url ='';
							if($tab_slug == "nexter_settings_welcome"){
								$nav_url = menu_page_url($tab_slug, false);
								$navicon = '<svg class="tab-nav-icon" version="1.1" xmlns="http://www.w3.org/2000/svg" width="120" height="120" viewBox="0 0 120 120" preserveAspectRatio="none">
											<path d="M109.148 120h-36c-1.104 0-2-0.9-2-2v-34h-20v34c0 1.1-0.896 2-2 2h-36c-1.104 0-2-0.9-2-2v-62h-8.648c-0.832 0-1.576-0.512-1.868-1.288-0.296-0.776-0.080-1.652 0.54-2.204l57.324-51c0.736-0.656 1.836-0.676 2.596-0.056l14.060 11.54v-10.992c0-1.104 0.896-2 2-2h20c1.1 0 2 0.896 2 2v31.648l19.74 18.908c0.588 0.568 0.776 1.432 0.472 2.192-0.308 0.756-1.044 1.252-1.86 1.252h-6.356v62c0 1.1-0.896 2-2 2zM75.148 116h32v-62c0-1.104 0.896-2 2-2h3.376l-16.756-16.056c-0.396-0.376-0.612-0.9-0.612-1.444v-30.5h-16v13.22c0 0.772-0.44 1.48-1.144 1.808-0.7 0.328-1.528 0.232-2.124-0.26l-16-13.136-52.124 46.368h5.396c1.104 0 2 0.896 2 2v62h32v-34c0-1.1 0.896-2 2-2h24c1.104 0 2 0.9 2 2v34h-0.012z"></path>
										</svg>';
							}
							if($tab_slug == "nexter_activate"){
								$nav_url = admin_url( 'admin.php?page=' . $tab_slug );
								$navicon = '<svg class="tab-nav-icon" xmlns="http://www.w3.org/2000/svg" width="15.204" height="28.507" viewBox="0 0 15.204 28.507"><g transform="translate(22.204) rotate(90)"><path d="M10.967,22.2H2.553A2.969,2.969,0,0,1,0,19.521V8.732C0,7.663.979,7,2.553,7h8.413C12.43,7,13.3,7.648,13.3,8.732v3.019H28.032a.476.476,0,0,1,.475.475v4.751a.477.477,0,0,1-.475.475H13.3V19.52A2.749,2.749,0,0,1,10.967,22.2ZM2.553,7.95c-.164,0-1.6.022-1.6.782V19.521a2.061,2.061,0,0,0,1.6,1.732h8.413c.67,0,1.386-1.016,1.386-1.731V16.977a.476.476,0,0,1,.475-.475H27.557V12.7H12.828a.475.475,0,0,1-.475-.475V8.733c0-.519-.467-.783-1.386-.783Z" /><path d="M18.826,14.95H15.975a.475.475,0,1,1,0-.95h2.851a.475.475,0,0,1,0,.95Z" transform="translate(-0.771 -0.348)" /><path d="M23.826,14.95H20.975a.475.475,0,0,1,0-.95h2.851a.475.475,0,0,1,0,.95Z" transform="translate(-1.02 -0.348)" /><path d="M27.876,14.95h-1.9a.475.475,0,1,1,0-.95h1.9a.475.475,0,0,1,0,.95Z" transform="translate(-1.269 -0.348)" /><path d="M5.376,18.552h-1.9A.476.476,0,0,1,3,18.077v-7.6A.475.475,0,0,1,3.475,10h1.9a.475.475,0,0,1,.475.475v7.6A.476.476,0,0,1,5.376,18.552ZM3.95,17.6H4.9V10.95H3.95Z" transform="translate(-0.149 -0.149)" /></g></svg>';
							}
							
							if($tab_slug == "nexter_white_label"){
								$nav_url = admin_url( 'admin.php?page=' . $tab_slug );
								$navicon = '<svg class="tab-nav-icon" xmlns="http://www.w3.org/2000/svg" width="30.152" height="27.537" viewBox="0 0 30.152 27.537">
								  <g transform="matrix(-0.788, 0.616, -0.616, -0.788, 34.922, 16.639)">
									<path d="M27.478,20.962H4.894a.466.466,0,0,1-.335-.144L.947,17.023a3.593,3.593,0,0,1,.008-5.266L4.567,8.136A.456.456,0,0,1,4.9,8H27.462a.462.462,0,0,1,.367.744L23.416,14.48l4.348,5.651a.466.466,0,0,1-.286.83ZM5.092,20.036H26.52l-4.056-5.273a.46.46,0,0,1,0-.564L26.52,8.927H5.086L1.609,12.412a2.671,2.671,0,0,0,0,3.966Z" />
									<path d="M6.33,17.43a2.778,2.778,0,1,1,2.778-2.778A2.782,2.782,0,0,1,6.33,17.43Zm0-4.629a1.852,1.852,0,1,0,1.852,1.852A1.853,1.853,0,0,0,6.33,12.8Z" transform="translate(-0.278 -0.287)"/>
									<path d="M18.581,13.926H13.026a.463.463,0,1,1,0-.926h5.555a.463.463,0,0,1,0,.926Z" transform="translate(-0.946 -0.371)"/>
									<path d="M18.581,16.926H13.026a.463.463,0,0,1,0-.926h5.555a.463.463,0,0,1,0,.926Z" transform="translate(-0.946 -0.593)"/>
								  </g>
								</svg>';
							}
							
							echo '<a class="'.esc_attr($nav_class).'" href="'.esc_url($nav_url).'">';
								echo '<span>'.$navicon.'</span>'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
								echo '<span>'.esc_html($option_tab['title']).'</span>';
							echo '</a>';
						endforeach;
						$out = ob_get_clean();
						$output .= $out;
					$output .='</div>';
				$output .='</div>';
			
			$output .='</div>';
			
			
		
			/*Content Options*/
			$output .='<div class="nxt-settings-form-wrapper form-'.esc_attr($tab_forms[0]['id']).'">';
			
				if(!empty($tab_forms)){
					ob_start();
					foreach ($tab_forms as $tab_form):
						
						if($tab_form['id']=='nexter_white_label'){
							do_action('nexter_white_label_notice');
						}else if($tab_form['id']=='nexter_activate'){
							do_action('nexter_activate_notice');
						}
						
						if(defined('NXT_PRO_EXT') && $tab_form['id']=='nexter_white_label'){								
							cmb2_metabox_form($tab_form, $tab_form['id']);
						}else if($tab_form['id']=='nexter_settings_welcome'){
							include_once NXT_THEME_DIR . 'inc/panel-settings/welcome-page.php';
						}
					endforeach;
					$out = ob_get_clean();
					$output .= $out;
				}
			$output .='</div>';
			
		$output .='</div>';
		
		echo $output; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}
	
	/**
     * Nexter Settings fields configuration
     */
    public function option_fields() {
		// Only need to initiate the array once per page-load
        if (!empty($this->option_metabox)) {
            return $this->option_metabox;
        }
		
		$this->option_metabox[] = array(
            'id' => 'nexter_settings_welcome',
            'title' => esc_html__('Welcome', 'nexter'),
            'show_on' => array(
                'key' => 'options-page',
                'value' => array(
                    'nexter_settings_welcome'
                )
            ),
            'show_names' => true,
            'fields' => ''
        );
		
		$this->option_metabox[] = array(
			'id' => 'nexter_activate',
			'title' => esc_html__('Activate', 'nexter'),
			'show_on' => array(
				'key' => 'options-page',
				'value' => array(
					'nexter_activate'
				)
			),
			'show_names' => true,
			'fields' => '',
		);
		
		$white_label_options=[];
		if(has_filter('nexter_white_label_options')) {
			$white_label_options = apply_filters('nexter_white_label_options', $white_label_options);
		}
		
		$this->option_metabox[] = array(
			'id' => 'nexter_white_label',
			'title' => esc_html__('White Label', 'nexter'),
			'show_on' => array(
				'key' => 'options-page',
				'value' => array(
					'nexter_white_label'
				)
			),
			'show_names' => true,
			'fields' => $white_label_options,
		);
		
		return $this->option_metabox;
	}
	
	/**
     * Public getter method for retrieving protected/private variables
     * @since  1.0.0
     * @param  string	$field Field to retrieve
     * @return mixed	Field value or exception is thrown
     */
    public function __get($field) {
        
        // Allowed fields to retrieve
        if (in_array($field, array('key','fields','title','options_page'), true)) {
            return $this->{$field};
        }
        if ('option_metabox' === $field) {
            return $this->option_fields();
        }
        /* translators: Invalid property: Fields */
        throw new Exception( sprintf( esc_html__( 'Invalid property: %1$s', 'nexter' ), $field ) );
    }
}

// Get it started
$Nexter_Settings_Panel = new Nexter_Settings_Panel();
$Nexter_Settings_Panel->hooks();