<?php
/**
 * Nexter Gutenberg Compatibility
 *
 * @package Nexter
 * @since	1.0.0
 */

if ( ! class_exists( 'Nexter_Gutenberg_Editor' ) ) {

	class Nexter_Gutenberg_Editor extends Nexter_Builder_Compatibility {
		
		public $template_post_id =[];
		
		public function __construct() {
			add_filter( 'tpgb_template_get_post_id', [ $this, 'tpgb_template_post_ids' ], 10, 1 );
		}
		
		/**
		 * Render content for post.
		 */
		public function render_content( $post_id ) {

			$output       = '';
			$current_post = get_post( $post_id, OBJECT );
			
			$this->template_post_id[] = $post_id;
			
			if ( has_blocks( $current_post ) ) {
				$blocks = parse_blocks( $current_post->post_content );
				foreach ( $blocks as $block ) {
					$output .= render_block( $block );
				}
			} else {
				$output = $current_post->post_content;
			}

			ob_start();
			echo do_shortcode( $output );
			echo ob_get_clean();	// phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
		}
		
		public function tpgb_template_post_ids( $post_ids ){
			
			$post_ids = array_merge($this->template_post_id, $post_ids);

			return $post_ids;
		}
		
		/**
		 * Load enqueue styles and scripts.
		 */
		public function enqueue_scripts( $post_id ) {

			if ( $post_id !== '' ) {
				if ( class_exists( 'Tp_Core_Init_Blocks' ) ) {
					$css_file = new Tp_Core_Init_Blocks();
					if ( !empty($css_file) && is_callable( array( $css_file, 'enqueue_post_css' ) ) ) {
						$css_file->enqueue_post_css( $post_id );
					}
				}
			}
		}

	}

}